using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using System.IO;
using System.Xml;
using System.Xml.Serialization;
using Microsoft.Web.Services2;
using Microsoft.Web.Services2.Messaging;
using Microsoft.Web.Services2.Addressing;
namespace WSPV_Client
{
	/// <summary>
	/// PseudoViewer web service client.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.TextBox tbStructure;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Button btRun;
		private System.Windows.Forms.LinkLabel linkLabel1;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.RichTextBox tbEsp;
		private System.Windows.Forms.TextBox tbSequence;
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			InitializeComponent();
			this.tbSequence.Text="UGUGCGUUUCCAUUUGAGUAUCCUGAAAACGGGCUUUUC\r\nAGCAUGGAACGUACAUAUUAAAUAGUAGGAGUGCAUAGU\r\nGGCCCGUAUAGCAGGCAUUAACAUUCCUGA";
			this.tbStructure.Text="(((((((.(((((........[[[[....[[[[....{{\r\n{{.))))))))))))........................\r\n..]]]].....]]]]...........}}}}";

		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form ̳ʿ  ڵ
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.tbStructure = new System.Windows.Forms.TextBox();
			this.btRun = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.linkLabel1 = new System.Windows.Forms.LinkLabel();
			this.label3 = new System.Windows.Forms.Label();
			this.panel1 = new System.Windows.Forms.Panel();
			this.label4 = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.tbEsp = new System.Windows.Forms.RichTextBox();
			this.tbSequence = new System.Windows.Forms.TextBox();
			this.panel1.SuspendLayout();
			this.SuspendLayout();
			// 
			// pictureBox1
			// 
			this.pictureBox1.Location = new System.Drawing.Point(8, 8);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(344, 256);
			this.pictureBox1.TabIndex = 0;
			this.pictureBox1.TabStop = false;
			// 
			// tbStructure
			// 
			this.tbStructure.Font = new System.Drawing.Font("Courier New", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.tbStructure.Location = new System.Drawing.Point(16, 288);
			this.tbStructure.Multiline = true;
			this.tbStructure.Name = "tbStructure";
			this.tbStructure.Size = new System.Drawing.Size(336, 240);
			this.tbStructure.TabIndex = 2;
			this.tbStructure.Text = "(((::[[[[)))::]]]]::::";
			// 
			// btRun
			// 
			this.btRun.Location = new System.Drawing.Point(272, 536);
			this.btRun.Name = "btRun";
			this.btRun.TabIndex = 3;
			this.btRun.Text = "Run";
			this.btRun.Click += new System.EventHandler(this.btRun_Click);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(104, 23);
			this.label1.TabIndex = 4;
			this.label1.Text = "Sequence data";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 272);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(128, 23);
			this.label2.TabIndex = 5;
			this.label2.Text = "Structure data";
			// 
			// linkLabel1
			// 
			this.linkLabel1.Location = new System.Drawing.Point(384, 336);
			this.linkLabel1.Name = "linkLabel1";
			this.linkLabel1.Size = new System.Drawing.Size(344, 40);
			this.linkLabel1.TabIndex = 6;
			this.linkLabel1.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkLabel1_LinkClicked);
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(368, 320);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(168, 16);
			this.label3.TabIndex = 7;
			this.label3.Text = "Structure Image Link";
			// 
			// panel1
			// 
			this.panel1.AutoScroll = true;
			this.panel1.Controls.Add(this.pictureBox1);
			this.panel1.Location = new System.Drawing.Point(368, 32);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(384, 272);
			this.panel1.TabIndex = 8;
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(368, 384);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(168, 23);
			this.label4.TabIndex = 10;
			this.label4.Text = "Structure in EPS format";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(368, 16);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(136, 24);
			this.label5.TabIndex = 11;
			this.label5.Text = "Structure Image";
			// 
			// tbEsp
			// 
			this.tbEsp.Location = new System.Drawing.Point(368, 400);
			this.tbEsp.Name = "tbEsp";
			this.tbEsp.Size = new System.Drawing.Size(384, 152);
			this.tbEsp.TabIndex = 12;
			this.tbEsp.Text = "";
			// 
			// tbSequence
			// 
			this.tbSequence.Font = new System.Drawing.Font("Courier New", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.tbSequence.Location = new System.Drawing.Point(16, 24);
			this.tbSequence.Multiline = true;
			this.tbSequence.Name = "tbSequence";
			this.tbSequence.Size = new System.Drawing.Size(336, 240);
			this.tbSequence.TabIndex = 1;
			this.tbSequence.Text = "CCUUACCUCGGGUAGAGGCCCA";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 14);
			this.ClientSize = new System.Drawing.Size(768, 566);
			this.Controls.Add(this.tbEsp);
			this.Controls.Add(this.tbStructure);
			this.Controls.Add(this.tbSequence);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.panel1);
			this.Controls.Add(this.linkLabel1);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.btRun);
			this.Controls.Add(this.label5);
			this.Name = "Form1";
			this.Text = "WSPseudoViewer Client";
			this.panel1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void linkLabel1_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			System.Diagnostics.Process.Start("IExplore",this.linkLabel1.Text);
		}

		private void btRun_Click(object sender, System.EventArgs e)
		{
			//make sure that web reference of PseudoVeiewer is referenced.
			//WSDL page: http://165.246.44.42/WSPseudoViewer/WSPseudoViewer.asmx?WSDL
			
			//create web service proxy
			WSPV.WSPseudoViewer proxy = new WSPV.WSPseudoViewer();
			//There are two kinds of web method WSPV support.
			//One is 'document/literal' type method. (use classes WSPVRequest, WSPVResponse, WSPVInput,.....)
			//The other 'rpc/encoded' type method. (use classes WSPVRequest1, WSPVResponse1, WSPVInput1,.....)
			//It will be easy to use 'document/literal' method in C#

			//'document/literal' methods are 'WSPVRun', 'WSPVServerTest' and 'WSPVServerRequestTest'
			//'rpc/encoded' methods are 'WSPVRunRpc', 'WSPVServerTestRpc' and 'WSPVServerRequestTestRpc'
			
			//make input data, WSPVRequest is the root element for calling 'WSPVRun' method.
			WSPV.WSPVRequest pvr=new WSPV.WSPVRequest();
			WSPV.WSPVOption option=new WSPV.WSPVOption();
			//set options, in this case we request url of png image, raw data of png image, eps data, and pseuoviewer generated 2D positions.
			option.Output_type="url png, raw png, eps, coord";
			option.Output_name="test";
			//There are many options of Drawing_option, but simply set 'default'.
			option.Drawing_option="default";
			pvr.Option=option;
			
			
			//Set the sequence data as the input data of the textbox named tbSequence.
			WSPV.WSPVInData pvinput=new WSPV.WSPVInData();
			pvinput.Sequence=new WSPV.WSPVSequence[1]{new WSPV.WSPVSequence()};
			pvinput.Sequence[0].Value=this.tbSequence.Text;
			
			//Set the structure data as the input data of the textbox named tbStructure.
			WSPV.BracketView structure=new WSPV.BracketView();
			structure.Text=this.tbStructure.Lines;
			pvinput.Item=structure;
			pvr.Items=new WSPV.WSPVInput[]{pvinput};

			WSPV.WSPVOutput[] response = null;
			try
			{
				//call web method 'WSPVRun'
				//If you want make sure that the PseudoViewer web server has no problem,
				// call 'proxy.WSPVServerTest()'. 'Server ok' is the response when the server is ok. :)
				//If you want check your input is correct,
				// call 'proxy.WSPVServerRequestTest( pvr )'. You can get 'Request ok' message, if your input is correct.
				response = proxy.WSPVRun( pvr );
			}
			catch( Exception ex )
			{
				MessageBox.Show( ex.ToString() );
				return;
			}
			WSPV.WSPVOutput pvout= response[0];
			for(int i=0;i<pvout.Images.Length;i++)
			{
				Type outputType=pvout.Images[i].GetType();
				if(outputType==typeof(WSPV.WSPVOutRawImage))
				{
					Byte[] imageData=((WSPV.WSPVOutRawImage)pvout.Images[i]).Picture.Value;
					MemoryStream imageStream=new System.IO.MemoryStream(imageData);
					this.pictureBox1.Image=new Bitmap(imageStream);
					this.pictureBox1.Width=this.pictureBox1.Image.Width;
					this.pictureBox1.Height=this.pictureBox1.Image.Height;
				}
				else if(outputType==typeof(WSPV.WSPVOutURL))
				{
					this.linkLabel1.Text=((WSPV.WSPVOutURL)pvout.Images[i]).Text[0];
				}
				else if(outputType==typeof(WSPV.WSPVOutEPS))
				{
					this.tbEsp.Lines=((WSPV.WSPVOutEPS)pvout.Images[i]).Text;
				}
			}
		}
	}
}
